--- kern/vfs_syscalls.c.orig
+++ kern/vfs_syscalls.c
@@ -3364,12 +3930,20 @@
 
 	AUDIT_ARG(mode, mode);
 restart:
+	if (dir_vn)
+		vrele(dir_vn);
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, segflg))
+		return (error);
 	bwillwrite();
-	NDINIT(&nd, CREATE, LOCKPARENT | SAVENAME | MPSAFE | AUDITVNODE1,
-	    segflg, path, td);
+	NDINIT_AT(&nd, CREATE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    SAVENAME | MPSAFE | AUDITVNODE1, segflg, path, td, dir_vn);
 	nd.ni_cnd.cn_flags |= WILLBEDIR;
-	if ((error = namei(&nd)) != 0)
+	if ((error = namei(&nd)) != 0) {
+		if (dir_vn)
+			vrele(dir_vn);
 		return (error);
+	}
 	vfslocked = NDHASGIANT(&nd);
 	vp = nd.ni_vp;
 	if (vp != NULL) {
@@ -3385,14 +3959,19 @@
 			vput(nd.ni_dvp);
 		vrele(vp);
 		VFS_UNLOCK_GIANT(vfslocked);
+		if (dir_vn)
+			vrele(dir_vn);
 		return (EEXIST);
 	}
 	if (vn_start_write(nd.ni_dvp, &mp, V_NOWAIT) != 0) {
 		NDFREE(&nd, NDF_ONLY_PNBUF);
 		vput(nd.ni_dvp);
 		VFS_UNLOCK_GIANT(vfslocked);
-		if ((error = vn_start_write(NULL, &mp, V_XSLEEP | PCATCH)) != 0)
+		if ((error = vn_start_write(NULL, &mp, V_XSLEEP | PCATCH)) != 0) {
+			if (dir_vn)
+				vrele(dir_vn);
 			return (error);
+		}
 		goto restart;
 	}
 	VATTR_NULL(&vattr);
@@ -3411,6 +3990,8 @@
 #ifdef MAC
 out:
 #endif
+	if (dir_vn)
+		vrele(dir_vn);
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vput(nd.ni_dvp);
 	if (!error)
@@ -3442,16 +4023,25 @@
 int
 kern_rmdir(struct thread *td, char *path, enum uio_seg pathseg)
 {
+	return kern_rmdirat(td, path, pathseg, AT_FDCWD);
+}
+
+int
+kern_rmdirat(struct thread *td, char *path, enum uio_seg pathseg, int dirfd)
+{
 	struct mount *mp;
-	struct vnode *vp;
+	struct vnode *vp, *dir_vn = NULL;
 	int error;
 	struct nameidata nd;
 	int vfslocked;
 
 restart:
+	error = kern_get_at(td, dirfd, &dir_vn);
+	if (error && !kern_absolute_path(path, pathseg))
+		return (error);
 	bwillwrite();
-	NDINIT(&nd, DELETE, LOCKPARENT | LOCKLEAF | MPSAFE | AUDITVNODE1,
-	    pathseg, path, td);
+	NDINIT_AT(&nd, DELETE, ((error) ? ATBADF : 0) | LOCKPARENT |
+	    LOCKLEAF | MPSAFE | AUDITVNODE1, pathseg, path, td, dir_vn);
 	if ((error = namei(&nd)) != 0)
 		return (error);
 	vfslocked = NDHASGIANT(&nd);
--- modules/Makefile.orig
+++ modules/Makefile
@@ -413,7 +413,6 @@
 _tmpfs= 	tmpfs
 _wi=		wi
 _xe=		xe
-.if ${MK_ZFS} != "no" || defined(ALL_MODULES)
 _zfs=		zfs
 .endif
 .if ${MACHINE} == "i386"
@@ -462,7 +461,6 @@
 _pmc=		pmc
 _snc=		snc
 .endif
-.endif
 
 .if ${MACHINE_ARCH} == "amd64"
 _aac=		aac
--- sys/fcntl.h.orig
+++ sys/fcntl.h
@@ -74,6 +74,10 @@
 #define	O_WRONLY	0x0001		/* open for writing only */
 #define	O_RDWR		0x0002		/* open for reading and writing */
 #define	O_ACCMODE	0x0003		/* mask for above modes */
+#if 0
+#define	O_EXEC		0x0004		/* open for execute only */
+#define	O_ACCMODE	0x0007		/* mask for above modes */
+#endif
 
 /*
  * Kernel encoding of open mode; separate read and write bits that are
@@ -96,15 +100,22 @@
 #define	O_FSYNC		0x0080		/* synchronous writes */
 #endif
 #define	O_SYNC		0x0080		/* POSIX synonym for O_FSYNC */
-#if __BSD_VISIBLE
 #define	O_NOFOLLOW	0x0100		/* don't follow symlinks */
-#endif
 #define	O_CREAT		0x0200		/* create if nonexistent */
 #define	O_TRUNC		0x0400		/* truncate to zero length */
 #define	O_EXCL		0x0800		/* error if already exists */
 #ifdef _KERNEL
 #define	FHASLOCK	0x4000		/* descriptor holds advisory lock */
 #endif
+/* Defined by POSIX Extended API ... TODO: number of the spec */
+#define	AT_FDCWD		-100	/* Use the current working directory
+					   to determine the target of relative
+					   file paths.
+					 */
+#define	AT_EACCESS		0x100	/* Check access using effective user and group ID */
+#define	AT_SYMLINK_NOFOLLOW	0x200   /* Do not follow symbolic links */
+#define	AT_SYMLINK_FOLLOW	0x400	/* Follow symbolic link */
+#define	AT_REMOVEDIR		0x800	/* Remove directory instead of file */
 
 /* Defined by POSIX 1003.1; BSD default, but must be distinct from O_RDONLY. */
 #define	O_NOCTTY	0x8000		/* don't assign controlling terminal */
@@ -114,6 +125,9 @@
 #define O_DIRECT	0x00010000
 #endif
 
+/* Defined by POSIX Extended API ... TODO: number of the spec */
+#define	O_DIRECTORY	0x00020000	/* Fail if not directory */
+
 /*
  * XXX missing O_DSYNC, O_RSYNC.
  */
@@ -220,6 +234,7 @@
 int	open(const char *, int, ...);
 int	creat(const char *, mode_t);
 int	fcntl(int, int, ...);
+int	openat(int, const char *, int, ...);
 #if __BSD_VISIBLE
 int	flock(int, int);
 #endif
--- sys/imgact.h.orig
+++ sys/imgact.h
@@ -45,6 +45,7 @@
 	int stringspace;	/* space left in arg & env buffer */
 	int argc;		/* count of argument strings */
 	int envc;		/* count of environment strings */
+	int fd;			/* file descriptor of the executable */
 };
 
 struct image_params {
--- sys/namei.h.orig
+++ sys/namei.h
@@ -66,7 +66,10 @@
 	/*
 	 * Arguments to lookup.
 	 */
-	struct	vnode *ni_startdir;	/* starting directory */
+	struct	vnode *ni_startdir;	/* 
+					 * starting directory, also used for 
+					 * rename and *at functions 
+					 */
 	struct	vnode *ni_rootdir;	/* logical root directory */
 	struct	vnode *ni_topdir;	/* logical top directory */
 	/*
@@ -106,8 +109,9 @@
 #define	NOCACHE		0x0020	/* name must not be left in cache */
 #define	FOLLOW		0x0040	/* follow symbolic links */
 #define	LOCKSHARED	0x0100	/* Shared lock leaf */
+#define	ATBADF		0x0200	/* called from *at context with invalid dirfd */
 #define	NOFOLLOW	0x0000	/* do not follow symbolic links (pseudo) */
-#define	MODMASK		0x01fc	/* mask of operational modifiers */
+#define	MODMASK		0x03fc	/* mask of operational modifiers */
 /*
  * Namei parameter descriptors.
  *
@@ -148,20 +152,23 @@
 /*
  * Initialization of a nameidata structure.
  */
-static void NDINIT(struct nameidata *, u_long, u_long, enum uio_seg,
-	    const char *, struct thread *);
+#define	NDINIT(ndp, op, flags, segflg, namep, td)	\
+		NDINIT_AT(ndp, op, flags, segflg, namep, td, NULL)
+
 static __inline void
-NDINIT(struct nameidata *ndp,
+NDINIT_AT(struct nameidata *ndp,
 	u_long op, u_long flags,
 	enum uio_seg segflg,
 	const char *namep,
-	struct thread *td)
+	struct thread *td,
+	struct vnode *dvp)
 {
 	ndp->ni_cnd.cn_nameiop = op;
 	ndp->ni_cnd.cn_flags = flags;
 	ndp->ni_segflg = segflg;
 	ndp->ni_dirp = namep;
 	ndp->ni_cnd.cn_thread = td;
+	ndp->ni_startdir = dvp;
 }
 
 #define NDF_NO_DVP_RELE		0x00000001
--- sys/stat.h.orig
+++ sys/stat.h
@@ -338,6 +338,10 @@
 #endif
 int	stat(const char * __restrict, struct stat * __restrict);
 mode_t	umask(mode_t);
+int	fstatat(int, const char *, struct stat *, int);
+int	mkdirat(int, const char *, mode_t);
+int	mkfifoat(int, const char *, mode_t);
+int	mknodat(int, const char *, mode_t, dev_t);
 __END_DECLS
 #endif /* !_KERNEL */
 
--- sys/syscallsubr.h.orig
+++ sys/syscallsubr.h
@@ -56,16 +56,24 @@
 	    socklen_t *namelen, struct file **fp);
 int	kern_access(struct thread *td, char *path, enum uio_seg pathseg,
 	    int flags);
+int	kern_accessat(struct thread *td, char *path, enum uio_seg pathseg,
+	    int flags, int dirfd);
 int	kern_adjtime(struct thread *td, struct timeval *delta,
 	    struct timeval *olddelta);
 int	kern_alternate_path(struct thread *td, const char *prefix, char *path,
-	    enum uio_seg pathseg, char **pathbuf, int create);
+	    enum uio_seg pathseg, char **pathbuf, int create, int dirfd);
 int	kern_bind(struct thread *td, int fd, struct sockaddr *sa);
 int	kern_chdir(struct thread *td, char *path, enum uio_seg pathseg);
 int	kern_chmod(struct thread *td, char *path, enum uio_seg pathseg,
 	    int mode);
+int	kern_chmodat(struct thread *td, char *path, enum uio_seg pathseg,
+	    mode_t mode, int dirfd);
 int	kern_chown(struct thread *td, char *path, enum uio_seg pathseg, int uid,
 	    int gid);
+int	kern_lchmodat(struct thread *td, char *path, enum uio_seg pathseg,
+	    mode_t mode, int dirfd);
+int	kern_chownat(struct thread *td, char *path, enum uio_seg pathseg, int uid,
+	    int gid, int dirfd);
 int	kern_clock_getres(struct thread *td, clockid_t clock_id,
 	    struct timespec *ts);
 int	kern_clock_gettime(struct thread *td, clockid_t clock_id,
@@ -102,18 +110,30 @@
 int	kern_kldunload(struct thread *td, int fileid, int flags);
 int	kern_lchown(struct thread *td, char *path, enum uio_seg pathseg,
 	    int uid, int gid);
+int	kern_lchownat(struct thread *td, char *path, enum uio_seg pathseg,
+	    int uid, int gid, int dirfd);
 int	kern_link(struct thread *td, char *path, char *link,
 	    enum uio_seg segflg);
+int	kern_linkat(struct thread *td, char *path, char *link,
+	    enum uio_seg segflg, int olddfd, int newdfd, int follow);
 int	kern_lstat(struct thread *td, char *path, enum uio_seg pathseg,
 	    struct stat *sbp);
+int	kern_lstatat(struct thread *td, char *path, enum uio_seg pathseg,
+	    struct stat *sbp, int dfd);
 int	kern_lutimes(struct thread *td, char *path, enum uio_seg pathseg,
 	    struct timeval *tptr, enum uio_seg tptrseg);
 int	kern_mkdir(struct thread *td, char *path, enum uio_seg segflg,
 	    int mode);
+int	kern_mkdirat(struct thread *td, char *path, enum uio_seg segflg,
+	    int mode, int dirfd);
 int	kern_mkfifo(struct thread *td, char *path, enum uio_seg pathseg,
 	    int mode);
+int	kern_mkfifoat(struct thread *td, char *path, enum uio_seg pathseg,
+	    int mode, int dirfd);
 int	kern_mknod(struct thread *td, char *path, enum uio_seg pathseg,
 	    int mode, int dev);
+int	kern_mknodat(struct thread *td, char *path, enum uio_seg pathseg,
+	    int mode, int dev, int dirfd);
 int	kern_msgctl(struct thread *, int, int, struct msqid_ds *);
 int	kern_msgsnd(struct thread *, int, const void *, size_t, int, long);
 int	kern_msgrcv(struct thread *, int, void *, size_t, long, int, long *);
@@ -121,6 +141,8 @@
 	    struct timespec *rmt);
 int	kern_open(struct thread *td, char *path, enum uio_seg pathseg,
 	    int flags, int mode);
+int	kern_openat(struct thread *td, char *path, enum uio_seg pathseg,
+	    int flags, int mode, int dirfd);
 int	kern_pathconf(struct thread *td, char *path, enum uio_seg pathseg,
 	    int name);
 int	kern_preadv(struct thread *td, int fd, struct uio *auio, off_t offset);
@@ -129,12 +151,17 @@
 int	kern_pwritev(struct thread *td, int fd, struct uio *auio, off_t offset);
 int	kern_readlink(struct thread *td, char *path, enum uio_seg pathseg,
 	    char *buf, enum uio_seg bufseg, int count);
+int	kern_readlinkat(struct thread *td, char *path, enum uio_seg pathseg,
+	    char *buf, enum uio_seg bufseg, int count, int dirfd);
 int	kern_readv(struct thread *td, int fd, struct uio *auio);
 int	kern_recvit(struct thread *td, int s, struct msghdr *mp,
 	    enum uio_seg fromseg, struct mbuf **controlp);
 int	kern_rename(struct thread *td, char *from, char *to,
 	    enum uio_seg pathseg);
+int	kern_renameat(struct thread *td, char *from, char *to,
+	    enum uio_seg pathseg, int fdirfd, int tdirfd);
 int	kern_rmdir(struct thread *td, char *path, enum uio_seg pathseg);
+int	kern_rmdirat(struct thread *td, char *path, enum uio_seg pathseg, int dirfd);
 int	kern_sched_rr_get_interval(struct thread *td, pid_t pid,
 	    struct timespec *ts);
 int	kern_semctl(struct thread *td, int semid, int semnum, int cmd,
@@ -165,17 +192,24 @@
 int	kern_sigsuspend(struct thread *td, sigset_t mask);
 int	kern_stat(struct thread *td, char *path, enum uio_seg pathseg,
 	    struct stat *sbp);
+int	kern_statat(struct thread *td, char *path, enum uio_seg pathseg,
+	    struct stat *sbp, int dfd);
 int	kern_statfs(struct thread *td, char *path, enum uio_seg pathseg,
 	    struct statfs *buf);
 int	kern_symlink(struct thread *td, char *path, char *link,
 	    enum uio_seg segflg);
+int	kern_symlinkat(struct thread *td, char *path, char *link,
+	    enum uio_seg segflg, int dirfd);
 int	kern_thr_new(struct thread *td, struct thr_param *param);
 int	kern_thr_suspend(struct thread *td, struct timespec *tsp);
 int	kern_truncate(struct thread *td, char *path, enum uio_seg pathseg,
 	    off_t length);
 int	kern_unlink(struct thread *td, char *path, enum uio_seg pathseg);
+int	kern_unlinkat(struct thread *td, char *path, enum uio_seg pathseg, int dirfd);
 int	kern_utimes(struct thread *td, char *path, enum uio_seg pathseg,
 	    struct timeval *tptr, enum uio_seg tptrseg);
+int	kern_utimesat(struct thread *td, char *path, enum uio_seg pathseg,
+	    struct timeval *tptr, enum uio_seg tptrseg, int dirfd);
 int	kern_wait(struct thread *td, pid_t pid, int *status, int options,
 	    struct rusage *rup);
 int	kern_writev(struct thread *td, int fd, struct uio *auio);
--- sys/time.h.orig
+++ sys/time.h
@@ -320,6 +320,7 @@
 int	setitimer(int, const struct itimerval *, struct itimerval *);
 int	settimeofday(const struct timeval *, const struct timezone *);
 int	utimes(const char *, const struct timeval *);
+int	futimesat(int, const char *, const struct timeval [2]);
 __END_DECLS
 
 #endif /* !_KERNEL */
